from dataclasses import dataclass, field


# automatické vytvoření konstruktoru, porovnání, vypisování
# frozen znamená, že po vytvoření nelze položky měnit (umožní hashování)
@dataclass(frozen=True)
class Point:
    x: int
    y: int
    # položka, která se nebude vypisovat a nebude se používat při porovnání
    p: "Point" = field(repr=False, compare=False)


p1 = Point(1, 2, None)
p2 = Point(1, 1, p1)

print(p1)
print(p1 == Point(1, 2, p2))

names = {
    p1: "A",
    p2: "B"
}
print(names[Point(1, 1, None)])
