class PostfixExpression:
    def __init__(self, expr_str) -> None:
        self.expression = expr_str.split()

    def evaluate(self):
        stack = []
        for token in self.expression:
            if token.isdigit():
                stack.append(int(token))
            else:
                b = stack.pop()
                a = stack.pop()
                stack.append(self.apply_operator(a, b, token))
        return stack.pop()

    # metoda, která nevyužívá žádné položky instance (nepotřebuje self)
    # do prvního argumentu se automaticky dosadí instance, to nechceme
    @staticmethod
    def apply_operator(x, y, op):
        if op == "+":
            return x + y
        elif op == "-":
            return x - y
        elif op == "*":
            return x * y
        elif op == "/":
            return x // y


# statickou metodu lze zavolat i bez instance
x = PostfixExpression.apply_operator(1, 2, "+")

expr = PostfixExpression("1 2 + 5 *")
print(expr.evaluate())
